SystemOrganization addCategory: #GODGraphGenerator!

Morph subclass: #GGGraph
	instanceVariableNames: 'horizontalLabel verticalLabel dataTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODGraphGenerator'!

GGGraph subclass: #GGBarGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODGraphGenerator'!

!GGBarGraph methodsFor: 'drawing' stamp: 'PM 10/31/2014 22:33'!
drawBar: canvas at: origin width: width height: height label: label
	"comment stating purpose of message"

	| r |
	r := Rectangle new.
	r setOrigin: ( origin x ) @ ( origin y - height ) corner: ( origin x + width ) @ ( origin y ).
	canvas fillRectangle: r color: Color blue.
	canvas drawString: label at: ( ( origin x + ( width // 2 ) ) - ( 7 * label size // 2 ) ) @ ( origin y - height - 14 )! !

!GGBarGraph methodsFor: 'drawing' stamp: 'PM 10/31/2014 22:55'!
drawOn: canvas
	"Draws the graph in a canvas to later turn into a morph"

	| i |
	canvas fillColor: Color white.
	canvas drawString: self horizontalLabel at: ( self width - ( 7 * self horizontalLabel size ) )@ ( self height - 14 ).
	canvas drawString: self verticalLabel at: 0@0.
	canvas line: ( 7 * self verticalLabel size ) @ 0 to: ( 7 * self verticalLabel size ) @ ( self height ) color: Color black.
	canvas line: (7 * self verticalLabel size - 14) @ ( self height - 14 ) to: self width @ ( self height - 14 ) color: Color black.
	i := 0.
	dataTable keysDo: [ :key |
		self drawBar: canvas at: ( ( 7 * self verticalLabel size ) + ( i * 40 ) + ( ( i + 1 ) * 10 ) ) @ ( self height - 14 ) width: 40 height: ( self dataTable at: key ) label: key.
		i := i + 1.
	]! !

!GGBarGraph methodsFor: 'initialize-release' stamp: 'WS 10/20/2014 01:45'!
width: width height: height
	self width: width.
	self height: height.
	^self! !

!GGGraph methodsFor: 'accessing' stamp: 'pm 10/5/2014 22:13'!
dataTable
	^ dataTable! !

!GGGraph methodsFor: 'export' stamp: 'PM 10/31/2014 20:47'!
exportToFile: filename
	"Export the graph to a PNG file"

	self exportAsPNGNamed: filename, '.png'! !

!GGGraph methodsFor: 'generate' stamp: 'PM 10/31/2014 21:40'!
generateGraph: aDictionary
"Set dataTable and generate the graph Morph"
	dataTable := aDictionary.
	self width: ( 7 * self verticalLabel size ) + ( 7 * self horizontalLabel size ) + ( dataTable size * 60 ) height: 5 * dataTable values asOrderedCollection max // 3! !

!GGGraph methodsFor: 'generate' stamp: 'PM 10/31/2014 20:47'!
generateGraph: dictionary toFile: filename
	"Generate the graph and export it to a png file"

	self generateGraph: dictionary.
	self exportToFile: filename.! !

!GGGraph methodsFor: 'accessing' stamp: 'pm 10/5/2014 21:46'!
horizontalLabel
	^ horizontalLabel! !

!GGGraph methodsFor: 'accessing' stamp: 'WS 10/20/2014 01:41'!
horizontalLabel: aString
	horizontalLabel := aString.
	^self! !

!GGGraph methodsFor: 'accessing' stamp: 'pm 10/5/2014 21:46'!
verticalLabel
	^ verticalLabel! !

!GGGraph methodsFor: 'accessing' stamp: 'WS 10/20/2014 01:41'!
verticalLabel: aString
	verticalLabel := aString.
	^self! !

GGGraph subclass: #GGLPieChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODGraphGenerator'!

GGGraph subclass: #GGLineGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODGraphGenerator'!
